/*
 * httpTools.java
 *
 * Copyright (c) David Pollack 2009
 * 
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following
 * conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 */

package ScrobbleBerry;

import java.io.*;
import javax.microedition.io.*;
import net.rim.device.api.ui.component.Dialog;
import net.rim.device.api.ui.component.Status;
import net.rim.device.api.system.Bitmap;


class httpTools {
    public static final int BES = 2;
    public static final int TCPIP = 3;
    public static final int WIFI = 4;
    
    public static HttpConnection createConn(String url,
                                            byte[] data,
                                            int connectionType) {
        HttpConnection theConn = null;
        OutputStream outStream = null;
        
        switch (connectionType) {
            case BES:
                url = url + ";deviceside=false";
                break;
            case TCPIP:
                url = url + ";deviceside=true";
                break;
            case WIFI:
                url = url + ";interface=wifi";
                break;
        }
        
        try {
            theConn = (HttpConnection) Connector.open(url);
            theConn.setRequestProperty("User-Agent",
                                    "Profile/MIDP-2.0 Configuration/CLDC-1.0");
            
            if (data == null) {
                theConn.setRequestMethod(HttpConnection.GET);
            } else {
                theConn.setRequestMethod(HttpConnection.POST);
                theConn.setRequestProperty("Content-Type",
                                           "application/x-www-form-urlencoded");
                theConn.setRequestProperty("Content-Length",
                                           String.valueOf(data.length));
                outStream = theConn.openOutputStream();
                outStream.write(data);
                outStream.flush();
            }
        } catch (IOException e) {
            Status.show("A connection error occurred; your scrobbles " +
                        "should be cached and will be submitted later.",
                        1000);
            if (theConn != null) {
                try {
                    theConn.close();
                } catch (IOException f) {
                }
                theConn = null;
            }
        } finally {
            if (outStream != null) {
                try {
                    outStream.close();
                } catch (IOException g) {
                }
            }
        }
        
        return theConn;
    }
} 
